#[cfg(feature = "serde")]
#[macro_use]
extern crate serde;

#[cfg(feature = "bidir-map")]
extern crate bidir_map;

extern crate indexmap;
extern crate snafu;

mod channel_permission;
mod convert;
mod data_type;
mod data_value;
mod error;
mod error_code;
mod job_stopped_reason;
mod module_channel_reference;
mod module_state;
mod override_option;
mod parameter_value;
mod storage_type;
mod storage_type_with_mixed;

pub use channel_permission::ChannelPermission;
pub use convert::TryConvertTo;
pub use data_type::{DataType, HasDataType};
pub use data_value::{
    ConstructParameterMask, DataValue, DataValueDescriptive, DataValueRaw,
    DeconstructParameterMask, IsParameterMask,
};
pub use error::{Error, Result};
pub use error_code::{ErrorCode, HasErrorCode};
pub use job_stopped_reason::JobStoppedReason;
pub use module_channel_reference::{
    IsModuleChannelReference, ModuleChannelReference,
};
pub use module_state::ModuleState;
pub use override_option::OverrideOption;
pub use parameter_value::{ParameterValue, ParameterValueRaw};
pub use storage_type::{HasStorageType, IsInStorageType, StorageType};
pub use storage_type_with_mixed::StorageTypeWithMixed;
